package com.cweb.controller.pay;

import com.hfkj.common.pay.WechatPayUtil;
import com.hfkj.common.pay.util.IOUtil;
import com.hfkj.common.pay.util.XmlUtil;
import com.hfkj.common.pay.util.sdk.WXPayConstants;
import com.hfkj.service.pay.NotifyService;
import com.hfkj.service.pay.PayRecordService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.BufferedOutputStream;
import java.util.*;

@Controller
@RequestMapping(value = "/wechatpay")
@Api(value = "微信支付")
public class WechatPayController {

    private static Logger log = LoggerFactory.getLogger(WechatPayController.class);

    private WXPayConstants.SignType signType;

    @Resource
    private NotifyService notifyService;

    @Resource
    private PayRecordService payRecordService;

    @Resource
    private WechatPayUtil wechatPayUtil;


    @RequestMapping(value = "/notify", method = RequestMethod.POST)
    @ApiOperation(value = "微信支付 -> 异步回调")
    public void wechatNotify(HttpServletRequest request, HttpServletResponse response) {
        try {
            log.info("微信支付 -> 异步通知：处理开始");

            String resXml = "";    // 反馈给微信服务器
            String notifyXml = null;    // 微信支付系统发送的数据（<![CDATA[product_001]]>格式）
            notifyXml = IOUtil.inputStreamToString(request.getInputStream(), "UTF-8");

            log.info("微信支付系统发送的数据：" + notifyXml);
            SortedMap<String, String> map = XmlUtil.parseXmlToTreeMap(notifyXml, "UTF-8");

            resXml = notifyService.wechatNotify(map);

/*            if (SignatureUtil.reCheckIsSignValidFromWeiXin(notifyXml, SysConst.getSysConfig().getWxApiKey(), "UTF-8")) {
                log.info("微信支付系统发送的数据：" + notifyXml);
                SortedMap<String, String> map = XmlUtil.parseXmlToTreeMap(notifyXml, "UTF-8");

                resXml = notifyService.wechatNotify(map);
            } else {
                log.error("微信支付 -> 异步通知：验签失败");
                log.error("apiKey：" + SysConst.getSysConfig().getWxApiKey());
                log.error("返回信息：" + notifyXml);
                resXml = "<xml>" + "<return_code><![CDATA[FAIL]]></return_code>"
                        + "<return_msg><![CDATA[签名验证错误]]></return_msg>" + "</xml> ";
            }*/

            BufferedOutputStream out = new BufferedOutputStream(response.getOutputStream());
            out.write(resXml.getBytes());
            out.flush();
            out.close();
            log.info("微信支付 -> 异步通知：处理完成");
        } catch (Exception e) {
            log.error("WechatPayController --> wechatNotify() error!", e);
        }
    }
}
